//Плагин makeContextMenu
(function ($) {
	var methods = {
		init: function (options) {
            var bindElemMenu = $(this);	
			
			//Рисуем меню
            var divElem = $("<div></div>").addClass("contextmenu").appendTo("body");
			var ulElem = $("<ul></ul>").addClass("context-menu-options").appendTo(divElem);

            if (options) {
                if (options.elementsMenu) {
                    $.each(options.elementsMenu, function (index, value) {
						$("<li>" + value.title + "</li>").appendTo(ulElem);
                });
				}
            }
            
			//Привязываем меню к элементам
            bindElemMenu.contextmenu(function (e) {
                if (e.target !== this)
                    return;
                e.preventDefault();
                $(".contextmenu").hide();
				var wWindow = $(window).width();
				var hWindow = $(window).height();
				var hMenu = divElem.height();
				var wMenu = divElem.width();
				var wRight = wWindow - (e.pageX + wMenu);
				var hTop = hWindow - (e.pageY + hMenu);
				if (wRight > 0) {
					divElem.css("left",e.pageX);
				} else {
					divElem.css("left",e.pageX + wRight);
				}
				if (hTop > 0) {
					divElem.css("top",e.pageY);
				} else {
					divElem.css("top",e.pageY + hTop);
				}
				divElem.css("display","block");
			});
			
			ulElem.find("li").on("click", function() {
                divElem.hide();
                if (options) {
                    if (options.elementsMenu) {
                        if (options.elementsMenu[$(this).index()].func)
                            options.elementsMenu[$(this).index()].func();
                    }
                }
            });
            $(document).on("click", function () { divElem.hide(); });
		}
	};
	$.fn.makeContextMenu = function (method) {
        // логика вызова метода
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Метод с именем ' + method + ' не существует для jQuery.makeContextMenu');
        }
    };
})(jQuery);