﻿//Плагин resizableTable
(function ($) {
    var left_shift = 0;
    var resizeTable = "";
    var oldX = "";
    var resizeColumn = "";
    var dataColumn = "";
    var methods = {
        init: function (options) {
            //Переделать одну таблицу в две отдельных
            var lexeygrid = {
                oldtable: $(this),
                oldhead: $(this).find("thead"),
                oldbody: $(this).find("tbody"),
                conteiner: $(this).parent()
            };
            $("<div class=\"lex-table\"></div>").append("<table></table>").prependTo(lexeygrid.conteiner);
            $(lexeygrid.conteiner).find(".lex-table").find("table").addClass("lex-table-cards").prepend(lexeygrid.oldbody);

            $("<div class=\"lex-head\"></div>").append("<table></table>").prependTo(lexeygrid.conteiner);
            $(lexeygrid.conteiner).find(".lex-head").find("table").addClass("lex-table-cards-header").prepend(lexeygrid.oldhead);

            $(lexeygrid.conteiner).find(".lex-table tr:eq(0)").addClass("width-columns");
            //var newrow = $("table.table-cards tr:eq(0)").clone().addClass("width-columns");
            //newrow.find("td").html("");

            //$("table.table-cards tr:eq(0)").before(newrow);
            $(lexeygrid.oldtable).remove();

            //Задаем начальную ширину колонок если задано
            if (options) {
                if (options.colwidth) {
                    options.colwidth.forEach(function (value, index) {
                        $(lexeygrid.conteiner).find("table.lex-table-cards-header th:eq(" + index + ")").css("width", value);
                        $(lexeygrid.conteiner).find("tr.width-columns td:eq(" + index + ")").css("width", value);
                    });
                }
                if (options.fsize) {
                    $(lexeygrid.conteiner).find("table.lex-table-cards-header").css("font-size", options.fsize);
                    $(lexeygrid.conteiner).find("table.lex-table-cards").css("font-size", options.fsize);
                }
            }

            // Перебор заголовков
            var headers = lexeygrid.oldhead.find("tr > th");
            $(headers).each(function (index) {
                var value = $(this).data("width");
                if (typeof value === "undefined" || value === "") value = "";
                if (value !== "") {
                    $(lexeygrid.conteiner).find("table.lex-table-cards-header th:eq(" + index + ")").css("width", value);
                    $(lexeygrid.conteiner).find("tr.width-columns td:eq(" + index + ")").css("width", value);
                }
            });

            //Добавляем в заголовок контролы изменения ширины
            $(lexeygrid.conteiner).find("table.lex-table-cards-header").find('th').each(function (e, o) {
                $("<span>&nbsp</span>").addClass("resize-mark").prependTo(o);
            });
            $("<div><div>").addClass("resize-mark-line").appendTo($(lexeygrid.conteiner).find("table.lex-table-cards-header").find("thead"));

            //Выделение строк
            $(lexeygrid.conteiner).find('table.lex-table-cards tbody tr').on("click contextmenu", function () {
                //$('table.table-cards tbody tr').removeClass("selected");
                $(this).parent().find('tr').removeClass("selected");
                $(this).addClass('selected');
                //lexeygrid.selectId = $(this).find('td:first-child').html();
            });


            //Функционал изменения размера таблицы
            $("th").on("mousedown", ".resize-mark", function (e) {
                left_shift = e.pageX - e.target.getBoundingClientRect().left;
                oldX = e.pageX;
                resizeColumn = $(this).parent();
                dataColumn = $(this).closest("div.lex-head").next("div.lex-table");
                $(lexeygrid.conteiner).find(".resize-mark-line").css("display", "block").css("height", $(".lex-table").css("height"));
                $(lexeygrid.conteiner).find(".resize-mark-line").css("left", e.target.getBoundingClientRect().left);
            }).on("mousemove", function (e) {
                if (oldX !== "" && resizeColumn !== "") {
                    $(".resize-mark-line").css("left", e.pageX - left_shift);
                }
            });

            $(window).on("mouseup", function (e) {
                if (oldX !== "" && resizeColumn !== "") {
                    var newX = e.pageX;
                    var cur_width = resizeColumn.width();

                    var newsize = 30;
                    if (oldX > newX) {
                        newsize = cur_width - (oldX - newX);
                    } else {
                        newsize = cur_width + (newX - oldX);
                    }

                    if (newsize < 30) {
                        newsize = 30;
                    }
                    resizeColumn.width(newsize);
                    //Изменяем так же и ширину колонки с данными
                    var data = dataColumn.find("tr.width-columns").find("td:eq(" + resizeColumn[0].cellIndex + ")");
                    data.css("width", newsize + 11);
                    $(".resize-mark-line").css("display", "none");
                    resizeX = ""; resizeColumn = ""; oldX = "";
                }
            });
        }
    };
    $.fn.makeTable = function (method) {
        // логика вызова метода
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Метод с именем ' + method + ' не существует для jQuery.makeTable');
        }
    };
})(jQuery);