﻿$(document).ready(function () {
    /* Установка года копирайт */
    $("footer span#copyright_year").html(new Date().getFullYear());

    let resizeMain = () => {
        let mainC = $(".main-content-container");
        let navH = $("nav").outerHeight();
        let footerH = $("footer").outerHeight();
        //mainC.css("margin-top", navH);
        mainC.css("height", $(window).height() - navH - footerH);
    };

    $(window).bind('resize', function () { //При событии изменении окна браузера
        resizeMain();
    });

    resizeMain();
});

// Установка фокуса и выделение текста в поле ввода в отчетах
function Set_field_focus(field) {
    if (field.length > 0) {
        field.focus();
        field.select();
        setTimeout(function () { field.select(); }, 100);
    }
}

// Добавить кнопку очистка полей фильтрации
function Add_btn_clear_filters() {
    var title = "Очистка всех полей фильтрации";
    var cell_th = $(".scroll-table table thead tr:nth-child(1) th:nth-child(1)");
    var btn_clear = $("<div title='" + title + "'>&nbsp;</div>").addClass("btn-clear-filters");

    $(cell_th).append(btn_clear);

    $(btn_clear).on("click", function () {
        $(".scroll-table table thead tr.filter input:not([type=button])").val("");
        $(".scroll-table table thead tr.filter select:not([type=button])").val("");
        $(".scroll-table table thead form").submit();
    });
}

// Добавить функционал кнопок сортировки
function Add_event_order_filters(title = "Сортировка") {
    $(".col-order").prop("title", title);
    // Добавление сортировки для колонок
    $(".col-order").on("click", function () {
        var col_this_index = $(this).parents("th").index();
        // Поле. признак что фильтр активен - текущий
        //var order_active_this = $(this).siblings("input.order-active");
        var order_active_this = $("tr.filter td:eq(" + col_this_index + ") input.order-active");
        // Поле признак что фильтр активен - у всех остальных
        var order_active_others = $("tr.filter input.order-active").not($(order_active_this));

        // Поле. тип сортировки - текущий
        //var order_type_this = $(this).siblings("input.order-type");
        var order_type_this = $("tr.filter td:eq(" + col_this_index + ") input.order-type");
        // Поле тип сортировки - у всех остальных
        var order_type_others = $("tr.filter input.order-type").not($(order_type_this));

        // Div. Все другие кнопки сортировки
        var col_order_others = $(".scroll-table table thead .col-order").not($(this));

        // Если выключен
        if ($(this).hasClass("order-Disabled")) {
            console.log("Был выключен -> Включить. Делаем по убыванию");
            $(this).toggleClass("order-Disabled order-Desc");
            // Активизируем текущую
            order_active_this.val(true);
            order_type_this.val("Desc")
        }
        // Если desc
        else if ($(this).hasClass("order-Desc")) {
            console.log("Включен. Был по убыванию -> Делаем по возрастанию");
            $(this).toggleClass("order-Desc order-Asc");
            // Активизируем текущую
            order_active_this.val(true);
            order_type_this.val("Asc")
        }
        // Если asc
        else if ($(this).hasClass("order-Asc")) {
            console.log("Включен. По возрастанию -> Выключаем");
            $(this).toggleClass("order-Asc order-Disabled");
            // Деактивируем текущую
            order_active_this.val(false);
            order_type_this.val("Disabled")
        }

        // Деактивируем остальные
        order_active_others.val(false);
        // Тип сортировки у остальных
        order_type_others.val("Disabled");
        col_order_others.removeClass("order-Desc order-Asc").addClass("order-Disabled");

        // Отправляем данные
        $("form#filter_form").submit();
    });
}

// Активация навигации стрелками по полям
function Report_use_arrows_controls(selector) {
    $(selector + " input:not(:disabled)").keydown(function (e) {
        // Left arrow
        if (e.which === 37) {
            var prev_field = $(e.target).parents("td").prev().find("input:not(:disabled)");
            Set_field_focus(prev_field);
        }
        // Right arrow
        if (e.which === 39) {
            var next_field = $(e.target).parents("td").next().find("input:not(:disabled)");
            Set_field_focus(next_field);
        }
        // Up arrow
        if (e.which === 38) {
            var prev_tr_field = $(e.target).parents("tr").prevAll().find("input[name=" + e.target.name + "]:not(:disabled)").last();
            Set_field_focus($(prev_tr_field));
        }
        // Down arrow
        if (e.which === 40) {
            var next_tr_field = $(e.target).parents("tr").nextAll().find("input[name=" + e.target.name + "]:not(:disabled)").first();
            Set_field_focus($(next_tr_field));
        }
    });

    // При изменении значений в отчетах устанавливаем признак не сохраненных данных
    $(selector + " input:not(:disabled)").on("input", function (e) {
        props.changes_not_saved = true;
    });
}

var dialogOptions = { title: "", href: "", position: { my: "center center", at: "center center", of: "main" }, resizable: false };
var globalSettings = { contentHeightOffset: 0, dialogWidth: 300, dialogHeight: 400, fullscreen: false };

// Системные сообщения
function Message(title, href, reload = true) {
    var dialog = "";
    $("<div></div>")
        .addClass("dialog")
        .appendTo("body")
        .load(href, function (e) {})
        .dialog({
            title: title,
            close: function () { $(this).remove(); if (reload) location.reload(); },
            modal: true,
            resizable: false,
            open: function () {
                dialog = $(this); // Текщуее открытое диалоговое окно
                $("<div></div>").appendTo($(this)).addClass("loading").html("Загрузка данных..."); //Прикрепляем загрузку к текущему окну
            },
            buttons: {
                "Закрыть": function () {
                    $(dialog).remove();
                }
            },
            position: { my: dialogOptions.position.my, at: dialogOptions.position.at, of: dialogOptions.position.of }
        });
}

// Сообщения при редактировании отчетов организации
function Message_no_url(title, data, no_controls = false) {
    var dialog = "";
    $("<div></div>")
        .addClass("dialog")
        .appendTo("body")
        .dialog({
            title: title,
            close: function () { $(this).remove(); },
            modal: true,
            resizable: false,
            open: function () {
                dialog = $(this); // Текщуее открытое диалоговое окно
                if (no_controls) {
                    $(dialog).siblings(".ui-dialog-titlebar-close").hide();
                    $(dialog).siblings(".ui-dialog-buttonpane").hide();
                }
                $("<div></div>").appendTo($(this)).addClass("loading").html("Загрузка данных..."); //Прикрепляем загрузку к текущему окну
                dialog.html(data);
            },
            buttons: {
                "Закрыть": function () {
                    $(dialog).remove();
                }
            },
            position: { my: dialogOptions.position.my, at: dialogOptions.position.at, of: dialogOptions.position.of }
        });

    return dialog;
}

/* Диалоговое окна подтверждения операции. Указывается функция удаления, заголовок и метод */
const СonfirmDialog = (func, title, href) => {
    let dialog = null;
    $("<div></div>").addClass("dialog").appendTo("body")
        .dialog({
            modal: true,
            resizable: false,
            title: "Подтверждение операции",
            close: function () { $(this).remove() },
            open: function () {
                dialog = $(this); //Устанавливаем диалог после создания пустого окна
                $("<div></div>").appendTo(dialog).html("Действие необратимо. Уверены?");
            },
            buttons: {
                "Yes": {
                    text: ("Да"),
                    'class': 'dialog-btn text-white bg-danger',
                    click: function () { $(dialog).dialog('destroy').remove(); func(title, href); } //Подтверждение операции
                },
                "No": {
                    text: ("Нет"),
                    'class': 'dialog-btn',
                    click: function () { $(dialog).dialog('destroy').remove(); } //Отмена операции
                },
            },
            position: { my: "center bottom", at: "center center", of: "main" }
        });
}

const ConfirmDialog_orgs_kinds = (msg, e) => {
    let dialog = null;
    e.preventDefault();  
    $("<div></div>").addClass("dialog").appendTo("body")
        .dialog({
            modal: true,
            resizable: false,
            title: "Подтверждение операции",
            close: function () { $(this).remove() },
            open: function () {
                dialog = $(this); //Устанавливаем диалог после создания пустого окна
                $("<div></div>").appendTo(dialog).html(msg);
            },
            buttons: { 
                "Yes": { // Подтверждение операции
                    text: ("Да"),
                    'class': 'dialog-btn text-white bg-danger',
                    click: function () {
                        $(dialog).dialog('destroy').remove();
                        if ($(e.target).prop("checked")) {
                            $(e.target).prop("checked", false);
                        } else {
                            $(e.target).prop("checked", true);
                        }
                    } 
                },
                "No": {
                    text: ("Нет"),
                    'class': 'dialog-btn',
                    click: function () { $(dialog).dialog('destroy').remove(); } //Отмена операции
                },
            },
            position: { my: "center bottom", at: "center center", of: "main" },
            width: 500
        });
}

const ConfirmDialog_save = (msg, func) => {
    let dialog = null;
    $("<div></div>").addClass("dialog").appendTo("body")
        .dialog({
            modal: true,
            resizable: false,
            title: "Подтверждение операции",
            close: function () { $(this).remove() },
            open: function () {
                dialog = $(this); //Устанавливаем диалог после создания пустого окна
                $("<div></div>").appendTo(dialog).html(msg);
            },
            buttons: {
                "Yes": {
                    text: ("Да"),
                    'class': 'dialog-btn text-white bg-danger',
                    click: function () { $(dialog).dialog('destroy').remove(); func(); } //Подтверждение операции
                },
                "No": {
                    text: ("Нет"),
                    'class': 'dialog-btn',
                    click: function () { $(dialog).dialog('destroy').remove(); props.changes_not_saved = false; } //Отмена операции
                },
            },
            position: { my: "center bottom", at: "center center", of: "main" },
            width: 500
        });
}

function ViewDialog(title, href, reload = true) {
    var dialog = "";
    $("<div></div>")
        .addClass("dialog")
        .appendTo("body")
        .load(href, function (e) {
            //datapickerSet(); /* Инициализируем датапикер после загрузки формы */
        })
        .dialog({
            title: title,
            close: function () { $(this).remove(); if (reload) location.reload(); },
            modal: true,
            open: function () {
                //$("<div></div>").appendTo(".dialog").addClass("loading").html("Загрузка данных...");
                dialog = $(this); // Текщуее открытое диалоговое окно
                $("<div></div>").appendTo($(this)).addClass("loading").html("Загрузка данных..."); //Прикрепляем загрузку к текущему окну
            },
            buttons: {
                "Сохранить": function () {
                    //if ($('.dialog form').length > 0) {
                    if ($(dialog).find('form')[0].length > 0) {
                        $.ajax({
                            //url: $('.dialog form')[0].action,
                            url: $(dialog).find('form')[0].action,
                            type: "POST",
                            //data: $('.dialog form').serialize(),
                            data: $(dialog).find('form').serialize(),
                            datatype: "json",
                            beforeSend: function () {
                                //$(".dialog").html("");
                                $(dialog).html("");
                                $(dialog).find(".ui-dialog-buttonset").hide();
                                //$("<div></div>").appendTo(".dialog").addClass("loading").html("Выполняется сохранение...");
                                $("<div></div>").appendTo($(dialog)).addClass("loading").html("Выполняется сохранение...");
                            },
                            success: function (result) {
                                //console.log(result);
                                //$(".ui-dialog-buttonset").show();
                                $(dialog).find(".ui-dialog-buttonset").show();
                                //$(".dialog").html(result);
                                $(dialog).html(result);
                            }
                        });
                    } else {
                        //$(".dialog").remove();
                        $(dialog).remove();
                    }
                    //location.reload();
                }
            },
            position: { my: dialogOptions.position.my, at: dialogOptions.position.at, of: dialogOptions.position.of }
        });
}